
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ZOJ - 3822 Domination （DP） / 憋错料</title>

    <meta name="description" content="ZOJ - 3822 Domination （DP） Edward is the headmaster of Marjar University. He is enthusiastic about chess and often plays chess with his friends. What's more, he bought a large decorative chessboard with N rows and M columns. Every day after work, Edward will place a chess piec">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">ZOJ - 3822 Domination （DP）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Edward is the headmaster of Marjar University. He is enthusiastic about chess and often plays chess with his friends. What‘s more, he bought a large decorative chessboard with&nbsp;<var>N</var>&nbsp;rows<br />
 and&nbsp;<var>M</var>&nbsp;columns.</p>
<p>Every day after work, Edward will place a chess piece on a random empty cell. A few days later, he found the chessboard was&nbsp;<em>dominated</em>&nbsp;by the chess pieces. That means there is<br />
 at least one chess piece in every row. Also, there is at least one chess piece in every column.</p>
<p>&quot;That‘s interesting!&quot; Edward said. He wants to know the expectation number of days to make an empty chessboard of&nbsp;<var>N</var>&nbsp;×&nbsp;<var>M</var>&nbsp;dominated. Please write a program to help<br />
 him.</p>
<h4>Input</h4>
<p>There are multiple test cases. The first line of input contains an integer&nbsp;<var>T</var>&nbsp;indicating the number of test cases. For each test case:</p>
<p>There are only two integers&nbsp;<var>N</var>&nbsp;and&nbsp;<var>M</var>&nbsp;(1 &lt;=&nbsp;<var>N</var>,&nbsp;<var>M</var>&nbsp;&lt;= 50).</p>
<h4>Output</h4>
<p>For each test case, output the expectation number of days.</p>
<p>Any solution with a relative or absolute error of at most 10<sup>-8</sup>&nbsp;will be accepted.</p>
<h4>Sample Input</h4>
<pre>2
1 3
2 2
</pre>
<h4>Sample Output</h4>
<pre>3.000000000000
2.666666666667
</pre>
<p>题意：求放石子使得每行没列都有石子个数的期望</p>
<p>思路：先求概率，然后再用期望公式计算，设dp[i][j][k]表示放i个石子后行有j，列有k至少有一个石子的概率，然后就是4种情况的讨论，1.使得行和列都加1，2.行加1，3.列加1</p>
<p>4.行和列都不加1</p>
<pre>#include &lt;iostream&gt;
#include &lt;cstdio&gt;
#include &lt;cstring&gt;
#include &lt;algorithm&gt;
#include &lt;cmath&gt;
using namespace std;
const int maxn = 55;

double dp[maxn*maxn][maxn][maxn];
int n, m;

int main() {
	int t;
	scanf(&quot;%d&quot;, &amp;t);
	while (t--) {
		scanf(&quot;%d%d&quot;, &amp;n, &amp;m);
		memset(dp, 0, sizeof(dp));
		dp[1][1][1] = 1.0;
		for (int i = 1; i &lt; n*m; i++)
			for (int j = 1; j &lt;= n; j++)
				for (int k = 1; k &lt;= m; k++)
					if (dp[i][j][k] &gt; 0) {
						dp[i+1][j+1][k+1] += dp[i][j][k] * (n - j) * (m - k) / (n * m - i);
						dp[i+1][j+1][k] += dp[i][j][k] * (n - j) * k / (n * m - i);

						dp[i+1][j][k+1] += dp[i][j][k] * j * (m - k) / (n * m - i);
						if (j &lt; n || k &lt; m)
							dp[i+1][j][k] += dp[i][j][k] * (j * k - i) / (n * m - i);
					}
		double ans = 0;
		for (int i = 1; i &lt;= n * m; i++)
			ans += dp[i][n][m] * i;
		printf(&quot;%.8lf\n&quot;, ans);
	}
	return 0;
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-08 01:57:09 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>ZOJ - 3822 Domination （DP）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QW6XE0.html" rel="bookmark">ZOJ 3822 Domination （概率DP）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Domination Time Limit: 8 Seconds      Memory Limit: 131072 KB      Special Judge Edward is the headmaster of Marjar University. He is enthusiastic about chess and often plays chess with his friends. What's more, he bought a large decorative chessboar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz5jLO4.html" rel="bookmark">ACM学习历程&mdash;&mdash;ZOJ 3822 Domination （2014牡丹江区域赛 D题）（概率，数学递推）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Description Edward is the headmaster of Marjar University. He is enthusiastic about chess and often plays chess with his friends. What's more, he bought a large decorative chessboard with N rows and M columns. Every day after work, Edward will place			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wNmYR0.html" rel="bookmark">zoj 3822 Domination（2014牡丹江区域赛D题）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Domination Time Limit: 8 Seconds      Memory Limit: 131072 KB      Special Judge Edward is the headmaster of Marjar University. He is enthusiastic about chess and often plays chess with his friends. What's more, he bought a large decorative chessboar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KjDz9M.html" rel="bookmark">zoj 3822 Domination 概率dp 2014牡丹江站D题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Domination Time Limit: 8 Seconds      Memory Limit: 131072 KB      Special Judge Edward is the headmaster of Marjar University. He is enthusiastic about chess and often plays chess with his friends. What's more, he bought a large decorative chessboar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myz2Ka0.html" rel="bookmark">ZOJ 3822 Domination 概率DP求期望</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Domination Time Limit: 8 Seconds      Memory Limit: 131072 KB      Special Judge Edward is the headmaster of Marjar University. He is enthusiastic about chess and often plays chess with his friends. What's more, he bought a large decorative chessboar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZYXB80.html" rel="bookmark">ZOJ 3822 Domination 概率DP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题意:在一个n*m的棋盘上放棋子,一个棋子可覆盖一行一列,若n行m列全被覆盖则停止放棋子,求棋子的期望 思路:期望DP, dp[i][j][k]表示放了i个棋子覆盖了j行k列 已知dp[0][0][0]=1,求dp[1~n*m][n][m] 四种情况: 1.再放一个棋子,行列都不增加 dp[i+1][j][k]+=dp[i][j][k]*(j*k-i)*1.0/(m*n-i); 2.只增加一行 dp[i+1][j+1][k]+=dp[i][j][k]*(n-j)*k*1.0/(m*n-i); 3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eyaYZ0.html" rel="bookmark">ZOJ 1743 Concert Hall Scheduling（DP）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接:http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=743 题意:有两个音乐厅出租.给出n个租客,每个租客有个租的时间段[L,R],以及租费.任意时候音乐厅只能租给最多一个租客.问如何选择租给哪些租客使得赚的钱最多? 思路:f[i][j]表示第一个音乐厅到时刻i.第二个到时刻j,可以获得的最大值. struct node { int x,y,w; int operator&lt;(const node &amp;a) const			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgEAWr3.html" rel="bookmark">ZOJ 1642 Match for Bonus（dp）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Match for Bonus Time Limit: 2 Seconds      Memory Limit: 65536 KB Roy played a game with his roommates the other day. His roommates wrote 2 strings of characters, and gave each character a bonus value. When Roy pinned the positions of one common char			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmGRrY3.html" rel="bookmark">hdu 5623 KK&amp;&num;39&semi;s Number（dp）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我们可爱的KK有一个有趣的数学游戏:这个游戏需要两个人,有N\left(1\leq N\leq 5*{10}^{4} \right)N(1≤N≤5∗10?4??)个数,每次KK都会先拿数.每次可以拿任意多个数,直到NN个数被拿完.每次获得的得分为取的数中的最小值,KK和对手的策略都是尽可能使得自己的得分减去对手的得分更大.在这样的情况下,最终KK的得分减去对手的得分会是多少? 输入描述 第一行一个数T\left( 1\leq T\leq 10\right)T(1≤T≤10),表示数据组			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/B0RYdyM.html" rel="bookmark" class="title">【uva 1615】Highway（算法效率--贪心 区间选点问题）</a>
					<div>
						题意:给定平面上N个点和一个值D,要求在x轴上选出尽量少的点,使得对于给定的每个店,都有一个选出的点离它的欧几里德距离不超过D. 解法:先把问题转换成模型,把对平面的点满足条件的点在x轴的直线上可得到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoGxEyM.html" rel="bookmark" class="title">泰勒级数</a>
					<div>
						一:函数的泰勒级数:设函数f(x),在点x0具有任意阶导数  称级数 为函数f(x) 的泰勒级数,显然只要函数存在任意阶导数,其泰勒级数必存在,例如 在点x=0处的泰勒级数为: 函数  f(x) 在x ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aAQrg0.html" rel="bookmark" class="title">两个 Long 类型为什么不能直接用&equals;&equals;比较</a>
					<div>
						这要说到==和 equals 的区别了. 1. ==比较的是两个对象在内存中的地址值(栈中的内容). 2.equals 是 java.lang.Object 类的一个方法.equals 比较的是两个对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGP9WG0.html" rel="bookmark" class="title">统计题2</a>
					<div>
						来自可汗统计课40: You sample 36 apples from your farm's harvest of over 200000 apples. The mean weight of t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylrNA4.html" rel="bookmark" class="title">怎样在Ubuntu手机平台中开发Cordova HTML5应用</a>
					<div>
						我们知道Cordova HTML5应用具有夸平台的特性,同一时候也具有訪问本地一些资源的能力.在今天的这篇文章中.我们将介绍一下怎样创建并执行一个Cordova HTML5的应用到我们的Ubuntu手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RDpgj4.html" rel="bookmark" class="title">主主漂移（切换）</a>
					<div>
						同时安装keepalived 依赖包[[email protected] keepalived-1.1.20]# yum install openssl-devel popt-devel -ymake ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZo2X3.html" rel="bookmark" class="title">【插件开发】&mdash;&mdash; 5 SWT控件以及布局使用</a>
					<div>
						前文回顾: 1 插件学习篇 2 简单的建立插件工程以及模型文件分析 3 利用扩展点,开发透视图 4 SWT编程须知 经过前几篇的介绍,多少对SWT又有了一些认识,那么这篇继续来看一下一些控件的组合使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZDnv3.html" rel="bookmark" class="title">异步编程Async&sol;await关键字</a>
					<div>
						异步编程Async \await 关键字在各编程语言中的发展(出现)纪实. 时间 语言版本 2012.08.15 C#5.0(VS2012) 2015.09.13 Python 3.5 2016.03 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDyyyK0.html" rel="bookmark" class="title">php 检查该数组有重复值</a>
					<div>
						if (count($array) != count(array_unique($array))) { echo '该数组有重复值'; }					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0koAEb0.html" rel="bookmark" class="title">在人山人海里，你不必记得我</a>
					<div>
						我们都是人生路途中的 旅人 这些年 我背着相机 四处游走 不断的出发和到达 不断的记录和感受 山川与河流 海洋与远方 路上  的每一寸光阴 都是时间给我的最好礼物 我从未忘记---- 出发 从未丢掉  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBxQqy3.html" rel="bookmark" class="title">仲氏偻烈抡tzn2z28s47q425</a>
					<div>
						首页时政国际国内财经文娱生活图片视频专栏双语爱出国 移动新媒体 中国搜索 中文国际 &gt; 独家 香港富商刘銮雄斥4.8亿购两颗巨钻赠爱女 曾因行贿被判刑 中国日报网信莲2015-11-12 17: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aRkyE3.html" rel="bookmark" class="title">4&period;50 抽象类的成员特点</a>
					<div>
						/* 抽象类的成员特点: 成员变量:既可以是变量,也可以是常量. 构造方法:有. 用于子类访问父类数据的初始化. 成员方法:既可以是抽象的,也可以是非抽象的. 抽象类的成员方法特性: A:抽象方法 强 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQKzeM.html" rel="bookmark" class="title">CentOS 6&period;4安装配置ldap</a>
					<div>
						一.安装ldap [[email protected] ~]# yum install openldap openldap-* -y [[email protected] ~]# yum instal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dREr74.html" rel="bookmark" class="title">石大ACM2588解题报告</a>
					<div>
						也是简单的石大校赛题,题目废话较多,就是求最小公倍数.由于涉及多个数,so写在函数里. //begin Taozifish是曾经的算法部部长,ACM俱乐部队长,带领大家拿过亚洲区域赛银牌.铜牌和省赛一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dzNy74.html" rel="bookmark" class="title">图解网络虚拟化之概念篇</a>
					<div>
						简单说就是把网络层的一些功能从硬件中剥离出来,新建立所谓的网络虚拟层.如果和服务器虚拟化对比来看,会帮助我们理解这个概念. 标签:虚拟化 VMware 认证 云计算 原创作品,允许转载,转载时请务必以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNdVlM.html" rel="bookmark" class="title">IE10-浏览器实现placeholder效果</a>
					<div>
						如下图,在文本框为空时显示提示文字 在IE10+和chrome浏览器加placeholder属性及可实现 ,单在IE10-浏览器并不支持该属性, 以下是placeholder在IE10-浏览器的实现  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzBGzlM.html" rel="bookmark" class="title">Android网络编程Socket【实例解析】</a>
					<div>
						Socket 其实和JavaWeb 里面的Socket一模一样 建立客服端,服务器端,服务器开一个端口供客服端访问 第一步创建服务器端:(这里把为了便于讲解,把服务器端,和客服端都放在手机上了) 创建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzBmkqM.html" rel="bookmark" class="title">李克强：金融改革，促进第三方支付的发展</a>
					<div>
						李克强在东北三省经济工作座谈会上强调把稳增长保就业提效益作为紧要之务在改革开放中实现东北新一 轮振兴 10日,中共中央政治局常委.国务院总理李克强在长春主持召开东北经济工作座谈会,研究推进东北发展 相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9aa50.html" rel="bookmark" class="title">shell 编程for循环总结</a>
					<div>
						shell编程for循环总结 在shell编程中,循环的执行是将某代码段重复运行多次,常用循环有for.while和until循环,其中for循环经常用于有限次循环,for循环的语法结构有如下两种:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e6dlg3.html" rel="bookmark" class="title">亏亏亏！视频网站花样不多只能亏</a>
					<div>
						笔者按:一件事如果形成习惯,就非常可怕.按部就班,没有变化,也就没有前进的动力和蜕变的可能.有所改变,有所行动,才能以正常的速度进化,达到梦想中的境界.在瞬息万变的互联网领域,不作为就意味着死亡. 对 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
